#!/bin/bash
source /etc/vdr.d/conf/gen2vdr.cfg
source /etc/vdr.d/conf/vdr

BLOCKFILE="$(grep "^BlockFile=" /etc/LCDd.conf |cut -f 2 -d "=")"
PLGS=" $PLUGINS "
X_CONSOLE=7
#set -x
logger -s "$0 <$1><$2> init"
[ -f /tmp/.shutdown ] && exit
if [ "$GUI" = "VDR" ] ; then
   NEW_CON="VDR"
elif [ "$1" = "-x" ] ; then
   NEW_CON="X"
elif [ "$1" = "-vdr" ] ; then
   NEW_CON="VDR"
elif [ "$1" = "-switch" ] ; then
   if [ "$(pidof -x /_config/bin/x2vdr.sh)" = "" ] ; then
      NEW_CON="VDR".
   else
      NEW_CON="X".....
   fi
else
   echo "Illegeal Parameter - must be -vdr or -x or -switch"
   exit
fi

logger -s "$0 <$1><$2> $NEW_CON"

echo "Switching to $NEW_CON"

if [ "$NEW_CON" = "X" ] ; then
   NC="$(/_config/bin/getXVT.sh -a)"
   if [ "$NC" = "" ] ; then
      echo "X ist nicht gestartet"
      exit
   fi..
   echo "VDR wird disabled"
   touch /tmp/.vdrdisabled
   [ -f /tmp/.freevodisabled ] && rm -f /tmp/.freevodisabled
   GUI_SWITCH_CONSOLE=1...
   svdrpsend.pl REMO off
   if [ "${PLGS#* alcd }" != "$PLGS" ] ; then
      svdrpsend.pl plug alcd lock
      afp-tool -a 0 -t FreeVo -L 0 -l 0
      [ "$BLOCKFILE" != "" ] && rm $BLOCKFILE 2>/dev/null
   fi
   [ "$REMOTE" = "ActivyFB" ] && screen -dm sh -c "killall -9 key2xd; key2xd /_config/freevo/freevo.key2x"
   sh /_config/bin/setscart.sh TVOUT
   if [ "$GUI" = "XBMC" -o "$GUI" = "FreeVo" ] ; then
      kill -9 $(pidof -x /usr/bin/vdr-sxfe /usr/bin/xine /_config/bin/vdr-xine.sh /_config/bin/x2vdr.sh) > /dev/null 2>&1
   fi
else
   if [ "$(pidof vdr)" = "" ] ; then
      for i in $(seq 1 10) ; do
         [ "$(pidof vdr)" != "" ] && break
         sleep 1
      done
      [ "$(pidof vdr)" = "" ] && echo "VDR ist nicht gestartet" && exit
   fi
   echo "VDR wird enabled"
   [ -f /tmp/.vdrdisabled ] && rm -f /tmp/.vdrdisabled
   touch /tmp/.freevodisabled
   killall -9 key2xd 2>/dev/null
   [ "$BLOCKFILE" != "" ] && touch $BLOCKFILE
   svdrpsend.pl REMO on
   [ "${PLGS#* alcd }" != "$PLGS" ] && svdrpsend.pl plug alcd unlock
   if [ "$(pidof -x freevo)" != "" ] ; then
      /_config/bin/frv2vdr.sh
   elif [ "$(pidof -x xbmc xbmc.bin)" != "" ] ; then
      killall -9 xbmc xbmc.bin
   fi
   NC=$VDR_CONSOLE
   sh /_config/bin/setscart.sh DVB
fi

if [ "$GUI_SWITCH_CONSOLE" = "1" ] || [ "$REMOTE" = "TASTATUR" ] ; then
   i=0
   while [ "$(fgconsole)" != "$NC" ] ; do
      logger -s "Switching to console $NC"
      killall -9 chvt >/dev/null 2>&1
      chvt $NC &
      if [ $i -ge 3 ] ; then
         break
      fi
      i=$(($i + 1))
      sleep 2
   done
fi
logger -s "$0 <$1><$2> $NEW_CON exit"
